<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:axsl="http://www.w3.org/1999/XSL/TransformAlias" version="1.0">
    <xsl:output indent="no" omit-xml-declaration="yes"/>
    <xsl:namespace-alias stylesheet-prefix="axsl" result-prefix="xsl"/>
    <xsl:template match="pnode[@id]">
        <xsl:apply-templates select="//description[./@ref=current()/@id]">
            <xsl:with-param name="nodetype">pnode</xsl:with-param>
        </xsl:apply-templates>
    </xsl:template>
    <xsl:template match="pnode[not(@id)] | rnode[not(@id)]">
        <xsl:copy-of select="."/>
    </xsl:template>
    <xsl:template match="rnode[@id]">
        <xsl:apply-templates select="//description[./@ref=current()/@id]">
            <xsl:with-param name="nodetype">rnode</xsl:with-param>
        </xsl:apply-templates>    
    </xsl:template>
       <xsl:template match="segment">
        <segment>
            <xsl:apply-templates select="*"/>
        </segment>
    </xsl:template>
    <xsl:template match="content">
        <xri>
            <content>
                <xsl:apply-templates/>
            </content>
        </xri>
    </xsl:template>
    <xsl:template match="/">
        <axsl:stylesheet version="1.0">
            <axsl:template match="/">
                <xsl:apply-templates select="//content"/>
            </axsl:template>
            <xsl:copy-of select="//preprocess/*"/>
             </axsl:stylesheet>

    </xsl:template>
    <xsl:template match="/xri/fields/description">
        <xsl:param name="nodetype"/>
        <xsl:variable name="descid" select="@ref"/>
        <xsl:element name="xsl:variable">
            <xsl:attribute name="name"><xsl:value-of select="$descid"/>
            </xsl:attribute>
            <xsl:attribute name="select">//variable[name='<xsl:value-of select="$descid"/>']/value</xsl:attribute>
        </xsl:element>
        <xsl:choose>
            <xsl:when test="preprocess">
                <!--<xsl:copy-of select="preprocess"/>-->
                <xsl:variable name="ppname" select="preprocess/xsl:template/@name"/>
                <axsl:variable name="ppvalue">
                    <axsl:call-template name="{$ppname}">
                        <axsl:with-param name="input" select="${$descid}"/>
                    </axsl:call-template>
                </axsl:variable>
                <xsl:if test="$nodetype='pnode'">
                    <pnode><axsl:value-of select="$ppvalue"/></pnode>
                </xsl:if>
                <xsl:if test="$nodetype='rnode'">
                    <rnode><axsl:value-of select="$ppvalue"/></rnode>
                </xsl:if>
            </xsl:when>
            <xsl:otherwise>
                <xsl:if test="$nodetype='pnode'">
                    <pnode><axsl:value-of select="${$descid}"/></pnode>
                </xsl:if>
                <xsl:if test="$nodetype='rnode'">
                    <rnode><axsl:value-of select="${$descid}"/></rnode>
                </xsl:if>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>
</xsl:stylesheet>
